<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:rich="http://richfaces.org/rich"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:g="http://www.ihe.net/gazelle"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['gazelle.PAMSimulator.DemographicsSharing']}</h1>
        <h:form id="patientForm">
            <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                <ui:param name="panel_id" value="selectPatients"/>
                <ui:param name="openByDefault" value="false"/>
                <ui:define name="panel_title">#{messages['gazelle.PAMSimulator.PatientsSelectedForSharing']}</ui:define>
                <ui:include src="/patient/_patientTable.xhtml">
                    <ui:param name="patients" value="#{patientSharingManager.selectedPatients}"/>
                </ui:include>
                <h:outputText value="#{messages['gazelle.PAMSimulator.IfYouWantOtherParticipantsToUseTheSameSetOfPatie']}"
                              styleClass="help-block"/>
                <dl class="dl-horizontal">
                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['gazelle.PAMSimulator.PatientSharingURL']}</ui:define>
                        <h:outputLink value="#{patientSharingManager.getUrlForSharing()}">
                            <h:outputText value="#{patientSharingManager.getUrlForSharing()}"/>
                        </h:outputLink>
                    </s:decorate>
                </dl>
            </ui:decorate>
        </h:form>
        <h:form id="systemSelectForm">
            <s:div styleClass="gzl-alert gzl-alert-blue"
                   rendered="#{patientSharingManager.isBp6Authorized()}">
                <span class="gzl-icon-info-circle"/>
                <h:outputText
                        value="#{messages['gazelle.pam.IfYouTickTheCheckboxBelowTheMessagesGeneratedByT']}"/>
                <s:decorate template="/layout/form/_checkbox.xhtml">
                    <h:selectBooleanCheckbox value="#{patientSharingManager.bp6Mode}">
                        <a4j:ajax event="change" render="systemSelectForm"/>
                    </h:selectBooleanCheckbox>
                    #{messages['gazelle.pam.NationalExtensionForFrance']}
                </s:decorate>
            </s:div>
            <gri:panel pid="systemsPanel">
                <f:facet name="header">#{messages['gazelle.PAMSimulator.SystemsToBeFed']}</f:facet>
                <div class="form-horizontal">
                    <h:outputText value="#{messages['gazelle.PAMSimulator.SelectTheSystemsOneByOneAndClickOnAdd']}"
                                  styleClass="help-bock"/>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="sut"/>
                        <ui:define name="label">#{messages['gazelle.HL7Common.SutConfiguration']}</ui:define>
                        <h:selectOneMenu value="#{patientSharingManager.systemToAdd}"
                                         styleClass="form-control  gzl-select-text" id="sut">
                            <f:selectItem noSelectionValue="true" itemValue="" itemLabel="#{messages['net.ihe.gazelle.simulators.PleaseSelect']}"/>
                            <f:selectItems value="#{patientSharingManager.availableSystemsUnderTest}"
                                           id="availableSUTList" var="availableSUT" itemValue="#{availableSUT}"  itemLabel="#{availableSUT.name}" />
                        </h:selectOneMenu>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.patientmanager.Add']}"
                                           actionListener="#{patientSharingManager.addSelectedSystemToList()}"
                                           render="systemsPanel"
                                           styleClass="gzl-btn-blue"/>
                    </s:decorate>
                </div>
                <rich:dataTable value="#{patientSharingManager.selectedSystems}" var="pref" id="sutList"
                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                render="dsSUT">
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.HL7Common.SutConfiguration']}</ui:define>
                        <h:outputText value="#{pref.systemUnderTest.name}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.HL7Common.Endpoint']}</ui:define>
                        <h:outputText value="#{patientSharingManager.getEndpointToDisplay(pref)}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.pam.AssigningAuthorities']}</ui:define>
                        <rich:list value="#{pref.assigningAuthorities}" var="aa">
                            <h:outputText value="#{aa.displayWithAmp()}"/>
                        </rich:list>
                        <a4j:commandLink actionListener="#{patientSharingManager.setSelectedPreferences(pref)}"
                                         oncomplete="jq162('#editAssigningAuthorityList').modal('show')"
                                         render="aaEditForm" title="#{messages['gazelle.PAMSimulator.EditListOfAssigningAuthorities']}">
                            <s:span styleClass="gzl-icon-pencil"/>
                        </a4j:commandLink>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.PAMSimulator.MessageToSend']}</ui:define>
                        <h:selectOneMenu value="#{pref.preferredMessage}"
                                         styleClass="form-control  gzl-select-text" id="msgSelect">
                            <f:selectItems value="#{pref.availableMessageTypes}"/>
                            <a4j:ajax event="change" listener="#{patientSharingManager.updateSUTPref(pref)}"
                                      render="sutList"/>
                        </h:selectOneMenu>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patgen.Actions']}</ui:define>
                        <a4j:commandLink actionListener="#{patientSharingManager.removeSUTFromList(pref)}"
                                         render="sutList,systemsPanel" title="#{messages['gazelle.PAMSimulator.RemoveFromList']}">
                            <s:span styleClass="gzl-icon-trash-o"/>
                        </a4j:commandLink>
                        <a4j:commandLink action="#{patientSharingManager.sendMessage(pref)}"
                                         render="messagesForm" title="#{messages['gazelle.simulator.pam.SendMessage']}">
                            <s:span styleClass="gzl-icon-play"/>
                        </a4j:commandLink>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="dsSUT"/>
                            <ui:param name="dataTableId" value="sutList"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
                <f:facet name="footer">
                    <a4j:commandButton value="#{messages['gazelle.PAMSimulator.RemoveAllSelectedSystems']}"
                                       oncomplete="jq162('#emptyListPopup').modal('show')"
                                       styleClass="gzl-btn-red"/>
                    <a4j:commandButton value="#{messages['gazelle.PAMSimulator.SendMessages']}"
                                       action="#{patientSharingManager.sendMessages()}"
                                       render="messagesForm, systemSelectForm"
                                       styleClass="gzl-btn-green"/>
                </f:facet>
            </gri:panel>
        </h:form>
        <h:form id="messagesForm">
            <s:div id="resultDiv">
                <gri:panel rendered="#{patientSharingManager.hasMessages() or not empty patientSharingManager.issues}">
                    <f:facet name="header">#{messages['gazelle.PAMSimulator.SharingReport']}</f:facet>
                    <ui:decorate template="/layout/form/_checkbox.xhtml">
                        <h:selectBooleanCheckbox value="#{patientSharingManager.autoRefresh}">
                            <a4j:ajax event="change" render="resultDiv"/>
                        </h:selectBooleanCheckbox>
                        #{messages['net.ihe.gazelle.patientmanager.AutorefreshTheListOfMessages']}
                    </ui:decorate>
                    <a4j:poll id="poll" interval="1000"
                              enabled="#{not patientSharingManager.areAllMessagesSent() and patientSharingManager.autoRefresh}"
                              render="resultDiv"/>
                    <s:div rendered="#{not empty patientSharingManager.issues}" styleClass="gzl-alert gzl-alert-red"
                           id="issuesDiv">
                        <rich:list value="#{patientSharingManager.issues}" var="issue">
                            <h:outputText value="#{issue}"/>
                        </rich:list>
                    </s:div>
                    #{dataTableStateHolder.setDescendingOn('timestamp')}
                    <ui:include src="/messages/message_table.xhtml">
                        <ui:param name="hl7Messages" value="#{patientSharingManager.messages}"/>
                    </ui:include>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.PAMSimulator.ClearList']}"
                                           actionListener="#{patientSharingManager.clearMessages()}"
                                           render="resultDiv"
                                           styleClass="gzl-btn-orange"/>
                    </f:facet>
                </gri:panel>
            </s:div>
        </h:form>
        <ui:include src="/cat/editAssigningAuthoritiesPanel.xhtml"/>
        <ui:include src="/cat/confirmEmptyList.xhtml"/>
    </ui:define>
</ui:composition>
